#include <signal.h>
#include <setjmp.h>
#include <stdio.h>


static jmp_buf ring;
 
void timeout(int sig)
{
  longjmp(ring, 1);
}


int ejecuta_con_tiempo(int (*func)(), int sec) {
  int res = -1;

  struct sigaction action;
  action.sa_handler = timeout;
  action.sa_flags = SA_RESTART | SA_NODEFER;

  sigaction(SIGALRM,&action,NULL);

  if(setjmp(ring) != 0) {
    // sigaction(SIGALRM, &action, NULL);
    return(-1);
  }

  alarm(sec);
  res = func();
  alarm(0);

  return(res);

}

int esperar() {
  sleep(3);
  return(1);
}

int main(int argc, char *argv[]) {

  printf("Invoco con 7, y retorna: %d\n", ejecuta_con_tiempo(esperar,7));
  printf("Invoco con 1, y retorna: %d\n", ejecuta_con_tiempo(esperar,1));
  printf("Invoco con 1, y retorna: %d\n", ejecuta_con_tiempo(esperar,1));


}
